//+------------------------------------------------------------------+
/////////////CYCLE TRIANGULAR CENTERED END-POINT  
//////////////Sohocool March 2012

//|                                       
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
 
 
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LawnGreen
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  1



//---- indicator parameters
extern int Fast_HalfLength    = 24;    
extern int Slow_HalfLength    = 48;
extern int PRICE              = 5; 

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//---- indicator buffers
double ind_buffer3a[];
double ind_buffer3b[];
double ind_buffer4[];
double slope[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ind_buffer3a);SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ind_buffer3b);SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ind_buffer4);
   SetIndexBuffer(3,slope);
   
   
   
   IndicatorShortName("Cycle Tma End-Point  ("+Fast_HalfLength+","+Slow_HalfLength+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) ind_buffer4[i]=iMA(NULL,0,Fast_HalfLength,0,3,PRICE,i) -iMA(NULL,0,Slow_HalfLength,0,3,PRICE,i);
   for(i=limit; i>=0; i--) 
   {
      ind_buffer3a[i]=EMPTY_VALUE;
      ind_buffer3b[i]=EMPTY_VALUE;      
      slope[i] = slope[i+1];
         if (ind_buffer4[i]>ind_buffer4[i+1]) slope[i] = 1;
         if (ind_buffer4[i]<ind_buffer4[i+1]) slope[i] =-1;
         if (slope[i] == 1) ind_buffer3a[i]=ind_buffer4[i];
         if (slope[i] ==-1) ind_buffer3b[i]=ind_buffer4[i];
   } 
   
   //
   //
   //
   //
   //
     
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (slope[whichBar] != slope[whichBar+1])
      if (slope[whichBar] == 1)
            doAlert("Buy");
      else  doAlert("Sell");       
   }

return(0);
}

//
//
//
//
//

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Cycle Tma End Point ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Cycle Tma End Point "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      
          